AchSnd_Defaults = {
-- Default Settings   All settings can be changed in game with
-- the /achsnd command
Guild = "on", -- Enable on guild member achievements
Party = "on", -- Enable on party members achievements
Near = "on",  -- Enable for people near you
--
--Addon Output Settings
MSBT = "on",  -- Output achievement to Mik's Scrolling Battle Text
Popup = "on", -- Grats popup
Sound = "on"  -- Enable Sound Output
}

AchSnd_Settings = {}
MDSet=0

local gmsg="{star} Grats {star}" -- Grats Message

AchSnd = CreateFrame("Frame")
AchSnd:RegisterEvent("ADDON_LOADED")
AchSnd:RegisterEvent("CHAT_MSG_ACHIEVEMENT")
AchSnd:RegisterEvent("CHAT_MSG_GUILD_ACHIEVEMENT")
SLASH_ACHSND1 = "/achsnd"

local function addOptionMt(options, defaults)
	setmetatable(options, {__index = defaults})
	for i, v in pairs(options) do
		if type(v) == "table" and not getmetatable(v) then
			addOptionMt(v, defaults[i])
		end
	end
end


AchSnd:SetScript("OnEvent",function(self, event,...)
	if (event == "ADDON_LOADED") then
		if (MDSet == 1) then
			return
		end
		print("Achievement Sounds loaded")
		addOptionMt(AchSnd_Settings, AchSnd_Defaults)
		MDSet = 1
		return self, event, ...
	end
	
	local args = {...}
	color = {255,255,255}
	mode = "DEFAULT"
	msg = args[1]:format(args[5])
	
	if (args[5] == UnitName("player")) then
		return
	end
	
	if (event == "CHAT_MSG_ACHIEVEMENT")then
		if (UnitInParty(args[5])) then
			if (AchSnd_Settings.Party ~="on") then 
				return
			end
			color = {0,255,255}
			mode = "PARTY"
		else
			if (AchSnd_Settings.Near ~="on")then
				return
			end
			color = {255,255,255}
			mode = "SAY"
		end
	end
	
	if (event == "CHAT_MSG_GUILD_ACHIEVEMENT") then
		if (AchSnd_Settings.Guild ~= "on") then
			return
		end
		color = {0,255,0}
		mode = "GUILD"
	end
	
	if (mode == "DEFAULT") then
		return
	end

	if ((AchSnd_Settings.MSBT == "on") and (not(MikSBT.IsModDisabled() ))) then
		MikSBT.DisplayMessage( msg , MikSBT.DISPLAYTYPE_NOTIFICATION, true, color[1], color[2], color[3])
	end

	if (AchSnd_Settings.Sound == "on") then
		PlaySound("LEVELUPSOUND")
	end
	
	if (AchSnd_Settings.Popup == "on") then
		StaticPopupDialogs["AchSnd"] = {
			text = msg,
			button1 = mode.." Grats",
			button2 = "Cancel",
			OnAccept = function(self)
				SendChatMessage( gmsg , mode )
			end,
			timeout = 15
			}
			
		StaticPopup_Show("AchSnd")
	end

end) 



SlashCmdList["ACHSND"] = function(msg)
	local cmd,arg = string.split(" ", msg)
	cmd = cmd:lower()
	yel = "|cFFFFFF00"
	grn = "|cFF00FF00"
	wht = "|cFFFFFFFF"
	red = "|cFFFF0000"
	res = "|r"
	if (cmd == "" ) then
		print(" ")
		print(" ")
		print(yel.."Achievement Sounds"..res)
		print(yel.."  Triggers:"..res)
		print(grn.."     Guild"..wht.." achievements are "..yel.. AchSnd_Settings.Guild ..res)
		print(grn.."     Party"..wht.." achievements are "..yel..AchSnd_Settings.Party..res)
		print(grn.."     Near"..wht.." achievements are "..yel..AchSnd_Settings.Near..res)
		print(yel.."  Outputs:")
		print(grn.."     Sound"..wht.." is "..yel..AchSnd_Settings.Sound..res)
		print(grn.."     MSBT"..wht.." is  "..yel..AchSnd_Settings.MSBT..res)
		print(grn.."     Popup"..wht.." is "..yel..AchSnd_Settings.Popup..res)
		print(yel.."Available commands are listed above in "..grn.."GREEN."..res)
		return
	end
	if (cmd == "guild") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.Guild = "on"
				print(yel.."Achievement Sounds: Guild is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Guild = "off"
				print(yel.."Achievement Sounds: Guild is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: Guild is now "..wht..AchSnd_Settings.Guild..res)
		end
	end
	
	if (cmd == "party") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.Party = "on"
				print(yel.."Achievement Sounds: Party is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Party = "off"
				print(yel.."Achievement Sounds: Party is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: Party is now "..wht..AchSnd_Settings.Party..res)
		end
	end

	if (cmd == "near") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.Near = "on"
				print(yel.."Achievement Sounds: Near is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Near = "off"
				print(yel.."Achievement Sounds: Near is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: Near is now "..wht..AchSnd_Settings.Near..res)
		end
	end

	if (cmd == "sound") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.Sound = "on"
				print(yel.."Achievement Sounds: Sound is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Sound = "off"
				print(yel.."Achievement Sounds: Sound is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: Sound is now "..wht..AchSnd_Settings.Sound..res)
		end
	end

	if (cmd == "msbt") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.MSBT = "on"
				print(yel.."Achievement Sounds: MSBT is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.MSBT = "off"
				print(yel.."Achievement Sounds: MSBT is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: MSBT is now "..wht..AchSnd_Settings.MSBT..res)
		end
	end

	if (cmd == "popup") then
		if ( arg ) then
			if ((arg == "1") or (arg == "on")) then
				AchSnd_Settings.Popup = "on"
				print(yel.."Achievement Sounds: Popup is now "..grn.."ON"..res)
			elseif ((arg == "0") or (arg == "off")) then
				AchSnd_Settings.Popup = "off"
				print(yel.."Achievement Sounds: Popup is now "..red.."OFF"..res)
			end
		else
			print(yel.."Achievement Sounds: Popup is now "..wht..AchSnd_Settings.Popup..res)
		end
	end
	
end
